--
-- Mod: WoodHarvesterManualCutting
-- Author: Bargon Mods
-- Email: bargonmods@gmail.com
-- Date: 16.12.2021
-- Version: 1.0.0.0
-- 
WoodHarvesterManualCutting = {}

function WoodHarvesterManualCutting.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(TurnOnVehicle, specializations)
end

function WoodHarvesterManualCutting.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", WoodHarvesterManualCutting)
end

function WoodHarvesterManualCutting.registerOverwrittenFunctions(vehicleType)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "onDelimbTree", WoodHarvesterManualCutting.onDelimbTree)
end

function WoodHarvesterManualCutting:onLoad(savegame)
    local spec = self.spec_woodHarvester

    spec.registerFound = false
end

function WoodHarvesterManualCutting:onDelimbTree(superFunc, state)
    local spec = self.spec_woodHarvester

    if state then
        spec.isAttachedSplitShapeMoving = true
    else
        spec.isAttachedSplitShapeMoving = false
        spec.registerFound = true
    end
end

function WoodHarvesterManualCutting:actionEventCutTree(superFunc, actionName, inputValue, callbackState, isAnalog)
    local spec = self.spec_woodHarvester

    if spec.hasAttachedSplitShape then
        if not spec.isAttachedSplitShapeMoving and self:getAnimationTime(spec.cutAnimation.name) == 1 then
            if spec.registerFound == true then
                self:cutTree(0)
                spec.registerFound = false
            else
                self:cutTree(spec.currentCutLength)
            end
        end
    elseif spec.curSplitShape ~= nil then
        self:cutTree(0)
        spec.registerFound = false
    end
end

WoodHarvester.actionEventCutTree = Utils.overwrittenFunction(WoodHarvester.actionEventCutTree,
    WoodHarvesterManualCutting.actionEventCutTree)

