--
-- Mod: WoodHarvesterManualCutting
-- Author: Bargon Mods
-- Email: bargonmods@gmail.com
-- Date: 16.12.2021
-- Version: 1.0.0.0
--
local modName = g_currentModName
local modDirectory = g_currentModDirectory

function addSpecializationToWoodHarvesterType()
    for typeName, typeEntry in pairs(g_vehicleTypeManager:getTypes()) do
        if SpecializationUtil.hasSpecialization(WoodHarvester, typeEntry.specializations) then
            g_vehicleTypeManager:addSpecialization(typeName, modName .. ".woodHarvesterManualCutting")
        end
    end
end

function addSpecialization()
    g_specializationManager:addSpecialization("woodHarvesterManualCutting", "WoodHarvesterManualCutting",
        modDirectory .. "src/WoodHarvesterManualCutting.lua", nil)

    if g_specializationManager:getSpecializationByName("woodHarvesterManualCutting") == nil then
        print("ERROR: WoodHarvesterManualCutting | Failed to add specialization")
    else
        addSpecializationToWoodHarvesterType()
    end
end

function validateTypes(types)
    if (types.typeName == 'vehicle') then
        addSpecialization()
    end
end

function init()
    TypeManager.validateTypes = Utils.prependedFunction(TypeManager.validateTypes, validateTypes)
end

init()

